## jgmenu 2.2.1

=== Makefile ===
#
# Define ASAN=1 to enable AddressSanitizer
#
# Define VERBOSE=1 for a more verbose compilation
#
# Define NO_LX=1 if you do not want to build jgmenu-lx (which requires
# libmenu-cache >=v1.1)
#

VER      = $(shell ./scripts/version-gen.sh)

# Allow user to override build settings without making tree dirty
-include config.mk

RM       = rm -f

prefix    ?= /usr/local
bindir     = $(prefix)/bin
libexecdir = $(prefix)/lib/jgmenu

ifeq ($(prefix),$(HOME))
datarootdir= $(prefix)/.local/share
else
datarootdir= $(prefix)/share
endif

CFLAGS  += -g -Wall -Os -std=gnu89
CFLAGS  += -Wextra -Wdeclaration-after-statement -Wno-format-zero-length \
	   -Wold-style-definition -Woverflow -Wpointer-arith \
	   -Wstrict-prototypes -Wunused -Wvla -Wunused-result
CFLAGS  += -Wno-unused-parameter
CFLAGS  += -DVERSION='"$(VER)"'

jgmenu:     CFLAGS  += `pkg-config cairo pango pangocairo librsvg-2.0 --cflags`
jgmenu-ob:  CFLAGS  += `xml2-config --cflags`
jgmenu-lx:  CFLAGS  += `pkg-config --cflags glib-2.0 libmenu-cache`
jgmenu-obtheme: CFLAGS  += `xml2-config --cflags`

jgmenu:     LIBS += `pkg-config x11 xrandr cairo pango pangocairo librsvg-2.0 --libs`
jgmenu:     LIBS += -pthread -lpng
jgmenu-ob:  LIBS += `xml2-config --libs`
jgmenu-lx:  LIBS += `pkg-config --libs glib-2.0 libmenu-cache`
jgmenu-obtheme: LIBS += `xml2-config --libs`

LDFLAGS += $(LIBS)

ifdef ASAN
ASAN_FLAGS = -O0 -fsanitize=address -fno-common -fno-omit-frame-pointer -rdynamic
CFLAGS    += $(ASAN_FLAGS)
LDFLAGS   += $(ASAN_FLAGS) -fuse-ld=gold
endif

ifndef VERBOSE
QUIET_CC   = @echo '     CC    '$@;
QUIET_LINK = @echo '     LINK  '$@;
endif

DEPDIR := .d
$(shell mkdir -p $(DEPDIR) >/dev/null)
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$*.Td

SCRIPTS_LIBEXEC = src/jgmenu-init.sh src/jgmenu-pmenu.py \
                  src/jgmenu-unity-hack.py src/jgmenu-config.py

PROGS_LIBEXEC   = jgmenu-ob jgmenu-socket jgmenu-i18n jgmenu-greeneye \
                  jgmenu-obtheme

# wrap in ifneq to ensure we respect user defined NO_LX=1
ifneq ($(NO_LX),1)
NO_LX := $(shell pkg-config "libmenu-cache >= 1.1.0" "glib-2.0" || echo "1")
endif
ifneq ($(NO_LX),1)
PROGS_LIBEXEC += jgmenu-lx
endif

PROGS           = jgmenu $(PROGS_LIBEXEC)

all: checkdeps $(PROGS)

jgmenu: jgmenu.o x11-ui.o config.o util.o geometry.o isprog.o sbuf.o \
	icon-find.o icon.o xpm-loader.o xdgdirs.o xsettings.o \
	xsettings-helper.o filter.o compat.o lockfile.o argv-buf.o t2conf.o \
	t2env.o unix_sockets.o bl.o cache.o back.o terminal.o restart.o \
	theme.o gtkconf.o font.o args.o widgets.o pm.o socket.o workarea.o \
	charset.o watch.o spawn.o
jgmenu-ob: jgmenu-ob.o util.o sbuf.o i18n.o hashmap.o
jgmenu-socket: jgmenu-socket.o util.o sbuf.o unix_sockets.o socket.o
ifneq ($(NO_LX),1)
jgmenu-lx: jgmenu-lx.o util.o sbuf.o xdgdirs.o argv-buf.o back.o fmt.o
endif
jgmenu-i18n: jgmenu-i18n.o i18n.o hashmap.o util.o sbuf.o
jgmenu-greeneye: jgmenu-greeneye.o compat.o util.o sbuf.o
jgmenu-apps: jgmenu-apps.o compat.o util.o sbuf.o desktop.o charset.o \
             xdgdirs.o argv-buf.o
jgmenu-obtheme: jgmenu-obtheme.o util.o sbuf.o compat.o

$(PROGS):
	$(QUIET_LINK)$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)

%.o : src/%.c
%.o : src/%.c $(DEPDIR)/%.d
	$(QUIET_CC)$(CC) $(DEPFLAGS) $(CFLAGS) -c $<
	@mv -f $(DEPDIR)/$*.Td $(DEPDIR)/$*.d && touch $@

$(DEPDIR)/%.d: ;
.PRECIOUS: $(DEPDIR)/%.d

install: checkdeps $(PROGS)
	@install -d $(DESTDIR)$(bindir)
	@install -m755 jgmenu src/jgmenu_run $(DESTDIR)$(bindir)
	@install -d $(DESTDIR)$(libexecdir)
	@install -m755 $(PROGS_LIBEXEC) $(SCRIPTS_LIBEXEC) $(DESTDIR)$(libexecdir)
	@./scripts/set-exec-path.sh $(DESTDIR)$(bindir)/jgmenu_run $(libexecdir)
	@$(MAKE) --no-print-directory -C docs/manual/ prefix=$(prefix) install
	@install -d $(DESTDIR)$(datarootdir)/icons/hicolor/scalable/apps/
	@install -d $(DESTDIR)$(datarootdir)/applications/
	@install -m644 ./data/jgmenu.svg $(DESTDIR)$(datarootdir)/icons/hicolor/scalable/apps/
	@install -m644 ./data/jgmenu.desktop $(DESTDIR)$(datarootdir)/applications/

# We are not brave enough to uninstall in /usr/, /usr/local/ etc
uninstall:
ifneq ($(prefix),$(HOME))
	@$(error uninstall only works if prefix=$(HOME))
endif
	@rm -f ~/bin/jgmenu
	@rm -f ~/bin/jgmenu_run
	@rm -rf ~/lib/jgmenu/
	@-rmdir ~/lib 2>/dev/null || true
	@rm -f ~/share/man/man1/jgmenu*
	@rm -f ~/share/man/man7/jgmenu*
	@-rmdir ~/share/man/man1 2>/dev/null || true
	@-rmdir ~/share/man/man7 ~/share/man ~/share 2>/dev/null || true
	@rm -f ~/.local/share/icons/hicolor/scalable/apps/jgmenu.svg
	@rm -f ~/.local/share/applications/jgmenu.desktop
	@-rmdir ~/.local/share/applications 2>/dev/null || true
	@-rmdir ~/.local/share/icons/hicolor/scalable/apps 2>/dev/null || true
	@-rmdir ~/.local/share/icons/hicolor/scalable 2>/dev/null || true
	@-rmdir ~/.local/share/icons/hicolor 2>/dev/null || true
	@-rmdir ~/.local/share/icons 2>/dev/null || true

clean:
	@$(RM) $(PROGS) *.o *.a $(DEPDIR)/*.d checkdeps
	@$(RM) -r .d/
	@$(MAKE) --no-print-directory -C tests/ clean
	@$(MAKE) --no-print-directory -C tests/helper/ clean

test:
	@$(MAKE) --no-print-directory -C tests/helper/ all
	@$(MAKE) --no-print-directory -C tests/ all

ex:
	@$(MAKE) --no-print-directory -C examples/ all

check:
	@./scripts/checkpatch-wrapper.sh src/*.c
	@./scripts/checkpatch-wrapper.sh src/*.h

REQUIRED_BINS := pkg-config xml2-config
REQUIRED_LIBS := x11 xrandr cairo pango pangocairo librsvg-2.0
checkdeps:
	@echo '     CHECK build dependencies'
	@for b in $(REQUIRED_BINS); do \
                type $${b} >/dev/null 2>&1 || echo "warn: require ($${b})"; \
        done
	@for l in $(REQUIRED_LIBS); do \
                pkg-config $${l} || echo "fatal: require ($${l})"; \
        done
	@if ! pkg-config "libmenu-cache >= 1.1.0" "glib-2.0"; then \
                echo "      - Cannot install lx module as build dependencies are missing"; \
	        echo "        libmenu-cache >= 1.1.0 and glib-2.0 are needed"; \
	        echo "        This will not prevent you from running jgmenu"; \
	fi
	@touch checkdeps

print-%:
	@echo '$*=$($*)'

SRCS = $(patsubst ./%,%,$(shell find ./src -maxdepth 1 -name '*.c' -print))
include $(wildcard $(patsubst %,$(DEPDIR)/%.d,$(basename $(SRCS))))

=== helper/Makefile ===
CC         = @echo '     CC    '$@;gcc
CFLAGS     = -g -Wall
ifdef ASAN
ASAN_FLAGS = -O0 -fsanitize=address -fno-common -fno-omit-frame-pointer -rdynamic
CFLAGS    += $(ASAN_FLAGS)
LDFLAGS   += $(ASAN_FLAGS) -fuse-ld=gold
endif
RM         = rm -f

src = ../../src/
util = $(src)util.c $(src)sbuf.c

TEST_PROGS = filter-out test-argv-buf test-hashmap test-sbuf test-xpm

all: $(TEST_PROGS)

filter-out: filter-out.c
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

test-hashmap: test-hashmap.c $(src)hashmap.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

test-argv-buf: test-argv-buf.c $(src)argv-buf.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

test-sbuf: test-sbuf.c $(src)sbuf.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

test-xpm: test-xpm.c $(src)xpm-loader.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS) `pkg-config cairo --cflags --libs`

clean :
	@$(RM) $(TEST_PROGS)

=== manual/Makefile ===
INSTALL = install
variant = --from=markdown_strict+backtick_code_blocks+pipe_tables+pandoc_title_block
css     = jg.css

man1pages  = jgmenu.1 jgmenu_run.1

man1pages += jgmenu-pmenu.1 jgmenu-lx.1 jgmenu-ob.1 jgmenu-config.1

man7pages  = jgmenututorial.7

manpages   = $(man1pages) $(man7pages)

prefix ?= /usr/local
mandir ?= $(prefix)/share/man
man1dir = $(mandir)/man1
man7dir = $(mandir)/man7

all: $(manpages)

$(manpages): % : %.md
	@echo "    PANDOC    " $^
	@pandoc -s -t man $^ -o $@
	@pandoc -s $(variant) --css=$(css) -o $@.html $^

install:
	@$(INSTALL) -d -m 755 $(DESTDIR)$(man1dir)
	@$(INSTALL) -d -m 755 $(DESTDIR)$(man7dir)
	@$(INSTALL) -m 644 $(man1pages) $(DESTDIR)$(man1dir)
	@$(INSTALL) -m 644 $(man7pages) $(DESTDIR)$(man7dir)

clean:
	rm -f $(manpages) *.html

=== debian/changelog ===
jgmenu (2.2.1-1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.
  * Simplify debian/rules.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 23 Apr 2019 17:09:23 -0700

jgmenu (2.2.1+bl8-1) jessie-backports; urgency=medium

  * New upstream release

 -- Johan Malm <jgm323@gmail.com>  Fri, 15 Mar 2019 21:10:09 +0000

=== debian/control ===
Source: jgmenu
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Johan Malm <jgm323@gmail.com>
Section: x11
Priority: optional
Standards-Version: 3.9.7
Build-Depends: debhelper (>= 9),
               libx11-dev,
               libxrandr-dev,
               libcairo2-dev,
               libpango1.0-dev,
               librsvg2-dev,
               libxml2-dev,
               libglib2.0-dev,
               libmenu-cache-dev,
               pkg-config

Package: jgmenu
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Description: simple X11 menu intended to be used with tint2 and openbox

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS   = hardening=+all
export DPKG_EXPORT_BUILDFLAGS    = 1
export DH_VERBOSE                = 1

include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --parallel

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

## jgmenu 4.3.0

=== Makefile ===
#
# Define ASAN=1 to enable AddressSanitizer
#
# Define VERBOSE=1 for a more verbose compilation
#
# Define CONTRIB_DIRS to include any contrib/ packages you wish to include
# The following are supported: CONTRIB_DIRS="xfce4-panel gtktheme lx"
#

VER      = $(shell ./scripts/version-gen.sh)

-include config.mk
include Makefile.inc

jgmenu:         CFLAGS += `pkg-config cairo pango pangocairo librsvg-2.0 --cflags`
jgmenu-ob:      CFLAGS += `xml2-config --cflags`
jgmenu-obtheme: CFLAGS += `xml2-config --cflags`
jgmenu-config:  CFLAGS += `pkg-config --cflags glib-2.0`

jgmenu:         LIBS   += `pkg-config x11 xrandr cairo pango pangocairo librsvg-2.0 --libs`
jgmenu:         LIBS   += -pthread -lpng
jgmenu-ob:      LIBS   += `xml2-config --libs`
jgmenu-obtheme: LIBS   += `xml2-config --libs`
jgmenu-config:  LIBS   += `pkg-config --libs glib-2.0`

LDFLAGS += $(LIBS)

DEPDIR := .d
$(shell mkdir -p $(DEPDIR) >/dev/null)
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$*.Td

SCRIPTS_LIBEXEC = src/jgmenu-init.sh \
                  src/jgmenu-unity-hack.py \
                  src/jgmenu-themes.sh \
                  src/jgmenu-hide-app.sh

PROGS_LIBEXEC   = jgmenu-ob jgmenu-socket jgmenu-i18n jgmenu-greeneye \
                  jgmenu-obtheme jgmenu-apps jgmenu-config

PROGS           = jgmenu $(PROGS_LIBEXEC)

all: config_mk $(PROGS)
	@for dir in $(CONTRIB_DIRS); do \
		$(MAKE) -C contrib/$$dir || exit 1; \
	done

config_mk:
	@if test ! -e config.mk; then \
		echo "fatal: you have not run ./configure"; \
		exit 1; \
	fi
	@:

jgmenu: jgmenu.o x11-ui.o config.o util.o geometry.o isprog.o sbuf.o \
	icon-find.o icon.o xpm-loader.o xdgdirs.o xsettings.o \
	xsettings-helper.o filter.o compat.o lockfile.o argv-buf.o t2conf.o \
	ipc.o unix_sockets.o bl.o cache.o back.o terminal.o restart.o \
	theme.o gtkconf.o font.o args.o widgets.o pm.o socket.o workarea.o \
	charset.o hooks.o spawn.o
jgmenu-ob: jgmenu-ob.o util.o sbuf.o i18n.o hashmap.o
jgmenu-socket: jgmenu-socket.o util.o sbuf.o unix_sockets.o socket.o compat.o
jgmenu-i18n: jgmenu-i18n.o i18n.o hashmap.o util.o sbuf.o
jgmenu-greeneye: jgmenu-greeneye.o compat.o util.o sbuf.o
jgmenu-apps: jgmenu-apps.o compat.o util.o sbuf.o desktop.o charset.o \
             xdgdirs.o argv-buf.o dirs.o lang.o fmt.o i18n.o hashmap.o
jgmenu-obtheme: jgmenu-obtheme.o util.o sbuf.o compat.o set.o
jgmenu-config: jgmenu-config.o util.o sbuf.o compat.o set.o spawn.o

$(PROGS):
	$(QUIET_LINK)$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)

%.o : src/%.c
%.o : src/%.c $(DEPDIR)/%.d
	$(QUIET_CC)$(CC) $(DEPFLAGS) $(CFLAGS) -c $<
	@mv -f $(DEPDIR)/$*.Td $(DEPDIR)/$*.d && touch $@

$(DEPDIR)/%.d: ;
.PRECIOUS: $(DEPDIR)/%.d

install: $(PROGS)
	@install -d $(DESTDIR)$(bindir)
	@install -m755 jgmenu src/jgmenu_run $(DESTDIR)$(bindir)
	@install -d $(DESTDIR)$(libexecdir)/jgmenu
	@install -m755 $(PROGS_LIBEXEC) $(SCRIPTS_LIBEXEC) $(DESTDIR)$(libexecdir)/jgmenu
	@./scripts/set-exec-path.sh $(DESTDIR)$(bindir)/jgmenu_run $(libexecdir)/jgmenu
	@$(MAKE) --no-print-directory -C docs/manual/ prefix=$(prefix) install
	@install -d $(DESTDIR)$(datarootdir)/icons/hicolor/scalable/apps/
	@install -d $(DESTDIR)$(datarootdir)/applications/
	@install -m644 ./data/jgmenu.svg $(DESTDIR)$(datarootdir)/icons/hicolor/scalable/apps/
	@install -m644 ./data/jgmenu.desktop $(DESTDIR)$(datarootdir)/applications/
	@for dir in $(CONTRIB_DIRS); do				\
		$(MAKE) -C contrib/$$dir install || exit 1;	\
	done

# We are not brave enough to uninstall in /usr/, /usr/local/ etc
uninstall:
ifneq ($(prefix),$(HOME))
	@$(error uninstall only works if prefix=$(HOME))
endif
	@rm -f ~/bin/jgmenu
	@rm -f ~/bin/jgmenu_run
	@rm -rf ~/lib/jgmenu/
	@-rmdir ~/lib 2>/dev/null || true
	@rm -f ~/share/man/man1/jgmenu*
	@rm -f ~/share/man/man7/jgmenu*
	@-rmdir ~/share/man/man1 2>/dev/null || true
	@-rmdir ~/share/man/man7 ~/share/man ~/share 2>/dev/null || true
	@rm -f ~/.local/share/icons/hicolor/scalable/apps/jgmenu.svg
	@rm -f ~/.local/share/applications/jgmenu.desktop
	@-rmdir ~/.local/share/applications 2>/dev/null || true
	@-rmdir ~/.local/share/icons/hicolor/scalable/apps 2>/dev/null || true
	@-rmdir ~/.local/share/icons/hicolor/scalable 2>/dev/null || true
	@-rmdir ~/.local/share/icons/hicolor 2>/dev/null || true
	@-rmdir ~/.local/share/icons 2>/dev/null || true
	@for dir in $(CONTRIB_DIRS); do				\
		$(MAKE) -C contrib/$$dir uninstall || exit 1;	\
	done

clean:
	@$(RM) $(PROGS) *.o *.a $(DEPDIR)/*.d
	@$(RM) -r .d/
	@$(MAKE) --no-print-directory -C tests/ clean
	@$(MAKE) --no-print-directory -C tests/helper/ clean
	@for dir in $(CONTRIB_DIRS); do				\
		$(MAKE) -C contrib/$$dir clean || exit 1;	\
	done

distclean: clean
	@$(RM) config.mk clang-format-tmpfile

test:
	@$(MAKE) --no-print-directory -C tests/helper/ all
	@$(MAKE) --no-print-directory -C tests/ all

prove:
	@$(MAKE) --no-print-directory -C tests/helper/ all
	@$(MAKE) --no-print-directory -C tests/ prove

ex:
	@$(MAKE) --no-print-directory -C examples/ all

check:
	@./scripts/check src/*.sh src/*.c src/*.h

print-%:
	@echo '$*=$($*)'

SRCS = $(patsubst ./%,%,$(shell find ./src -maxdepth 1 -name '*.c' -print))
include $(wildcard $(patsubst %,$(DEPDIR)/%.d,$(basename $(SRCS))))

.PHONY: all install uninstall clean distclean test prove ex check

=== debian/changelog ===
jgmenu (4.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #882210)

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Sun, 28 Feb 2021 21:15:19 +0100

=== debian/control ===
Source: jgmenu
Maintainer: Mateusz Łukasik <mati75@linuxmint.pl>
Section: x11
Priority: optional
Standards-Version: 4.5.1
Homepage: https://jgmenu.github.io/
Build-Depends: debhelper-compat (= 13), libx11-dev, libxrandr-dev, libcairo2-dev,
 libpango1.0-dev, librsvg2-dev, libxml2-dev, libglib2.0-dev, libmenu-cache-dev,
 pkg-config, libgtk-3-dev, libxfce4panel-2.0-dev
Vcs-Git: https://github.com/mati75/jgmenu.git
Vcs-Browser: https://github.com/mati75/jgmenu
Rules-Requires-Root: no

Package: jgmenu
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Suggests: lxmenu-data
Description: Simple X11 menu
 A stand-alone, contemporary-looking menu application for Linux and BSD.
 Independent of window manager and panel. Designed for customisation,
 scripting, ricing and tweaking

Package: jgmenu-xfce4-panel-applet
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, jgmenu (= ${binary:Version})
Description: xfce4-panel applet for jgmenu
 A stand-alone, contemporary-looking menu application for Linux and BSD.
 Independent of window manager and panel. Designed for customisation,
 scripting, ricing and tweaking
 .
 This package provides xfce4-panel applet for jgmenu

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		--prefix=/usr \
		--with-lx \
		--with-xfce4-panel-applet \
		--with-gtktheme

override_dh_auto_build:
	dh_auto_build -- CONTRIB_DIRS="xfce4-panel gtktheme"

override_dh_auto_install:
	dh_auto_install -- prefix=/usr CONTRIB_DIRS="xfce4-panel gtktheme"

## jgmenu 4.4.0

=== Makefile ===
--- 
+++ 
@@ -62,7 +62,7 @@
 jgmenu-i18n: jgmenu-i18n.o i18n.o hashmap.o util.o sbuf.o
 jgmenu-greeneye: jgmenu-greeneye.o compat.o util.o sbuf.o
 jgmenu-apps: jgmenu-apps.o compat.o util.o sbuf.o desktop.o charset.o \
-             xdgdirs.o argv-buf.o dirs.o lang.o fmt.o i18n.o hashmap.o
+             xdgdirs.o argv-buf.o dirs.o lang.o fmt.o i18n.o hashmap.o isprog.o
 jgmenu-obtheme: jgmenu-obtheme.o util.o sbuf.o compat.o set.o
 jgmenu-config: jgmenu-config.o util.o sbuf.o compat.o set.o spawn.o

=== contrib/lx/Makefile ===
-include ../../config.mk
include ../../Makefile.inc

CFLAGS  += `pkg-config --cflags glib-2.0 libmenu-cache`
LDFLAGS += `pkg-config --libs glib-2.0 libmenu-cache`

path = ../../src/
src  = util.c sbuf.c xdgdirs.c argv-buf.c back.c fmt.c

jgmenu-lx: jgmenu-lx.c
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ $^ $(addprefix $(path),$(src)) -I$(path) $(LDFLAGS)

install:
	@install -d $(DESTDIR)$(libexecdir)/jgmenu
	@install -m755 jgmenu-lx $(DESTDIR)$(libexecdir)/jgmenu

clean:
	@rm -f jgmenu-lx

=== tests/helper/Makefile ===
CC         = @echo '     CC    '$@;gcc
CFLAGS     = -g -Wall
ifdef ASAN
ASAN_FLAGS = -O0 -fsanitize=address -fno-common -fno-omit-frame-pointer -rdynamic
CFLAGS    += $(ASAN_FLAGS)
LDFLAGS   += $(ASAN_FLAGS) -fuse-ld=gold
endif
RM         = rm -f

src = ../../src/
util = $(src)util.c $(src)sbuf.c

TEST_PROGS = filter-out test-argv-buf test-hashmap test-sbuf test-xpm \
	     test-dirs test-xdgdirs

all: $(TEST_PROGS)

filter-out: filter-out.c
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

test-hashmap: test-hashmap.c $(src)hashmap.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

test-argv-buf: test-argv-buf.c $(src)argv-buf.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

test-sbuf: test-sbuf.c $(src)sbuf.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

test-xpm: test-xpm.c $(src)xpm-loader.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS) `pkg-config cairo --cflags --libs`

test-dirs: test-dirs.c $(src)dirs.c $(src)xdgdirs.c $(src)argv-buf.c $(src)compat.c $(src)lang.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

test-xdgdirs: test-xdgdirs.c $(src)xdgdirs.c $(src)argv-buf.c $(util)
	$(CC) $(CFLAGS) -o $@ $^ -I$(src) $(LDFLAGS)

clean :
	@$(RM) $(TEST_PROGS)

=== debian/changelog ===
jgmenu (4.4.0-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 11 Oct 2022 18:11:36 -0700

jgmenu (4.4.0-1) unstable; urgency=medium

  * New upstream release.
  * Enable install lx plugin. (Closes: #983907)
  * Bump Standards Version to 4.6.0.
  * Change depends to python3:any.

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Wed, 13 Oct 2021 17:27:44 +0200

=== debian/control ===
Source: jgmenu
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Mateusz Łukasik <mati75@linuxmint.pl>
Section: x11
Priority: optional
Standards-Version: 4.6.0
Homepage: https://jgmenu.github.io/
Build-Depends: debhelper-compat (= 13),
               libcairo2-dev,
               libglib2.0-dev,
               libgtk-3-dev,
               libmenu-cache-dev,
               libpango1.0-dev,
               librsvg2-dev,
               libx11-dev,
               libxfce4panel-2.0-dev,
               libxml2-dev,
               libxrandr-dev,
               pkg-config
Vcs-Git: https://github.com/mati75/jgmenu.git
Vcs-Browser: https://github.com/mati75/jgmenu
Rules-Requires-Root: no

Package: jgmenu
Architecture: any
Multi-Arch: foreign
Depends: python3:any, ${misc:Depends}, ${shlibs:Depends}
Suggests: lxmenu-data
Description: Simple X11 menu
 A stand-alone, contemporary-looking menu application for Linux and BSD.
 Independent of window manager and panel. Designed for customisation,
 scripting, ricing and tweaking

Package: jgmenu-xfce4-panel-applet
Architecture: any
Multi-Arch: same
Depends: jgmenu (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: xfce4-panel applet for jgmenu
 A stand-alone, contemporary-looking menu application for Linux and BSD.
 Independent of window manager and panel. Designed for customisation,
 scripting, ricing and tweaking
 .
 This package provides xfce4-panel applet for jgmenu

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,11 @@
 		--with-gtktheme
 
 override_dh_auto_build:
-	dh_auto_build -- CONTRIB_DIRS="xfce4-panel gtktheme"
+	dh_auto_build -- CONTRIB_DIRS="xfce4-panel gtktheme lx"
 
 override_dh_auto_install:
-	dh_auto_install -- prefix=/usr CONTRIB_DIRS="xfce4-panel gtktheme"
+	dh_auto_install -- prefix=/usr CONTRIB_DIRS="xfce4-panel gtktheme lx"
+
+# No dbgsym package for MX:
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## jgmenu 4.4.1

=== Makefile ===
--- 
+++ 
@@ -16,12 +16,14 @@
 jgmenu-ob:      CFLAGS += `xml2-config --cflags`
 jgmenu-obtheme: CFLAGS += `xml2-config --cflags`
 jgmenu-config:  CFLAGS += `pkg-config --cflags glib-2.0`
+jgmenu-apps:    CFLAGS += `pkg-config --cflags glib-2.0`
 
 jgmenu:         LIBS   += `pkg-config x11 xrandr cairo pango pangocairo librsvg-2.0 --libs`
 jgmenu:         LIBS   += -pthread -lpng
 jgmenu-ob:      LIBS   += `xml2-config --libs`
 jgmenu-obtheme: LIBS   += `xml2-config --libs`
 jgmenu-config:  LIBS   += `pkg-config --libs glib-2.0`
+jgmenu-apps:    LIBS   += `pkg-config --libs glib-2.0`
 
 LDFLAGS += $(LIBS)

=== examples/Makefile ===
export ASAN_OPTIONS=detect_leaks=0

all:
	@./ex01.sh
	@./ex02.sh
	@./ex03.sh
	@./ex04.sh
	@./ex05.sh
	@./ex06.sh
	@./ex07.sh
	@./ex08.sh

=== tests/Makefile ===
# Run tests
#
# Copyright (c) 2011-2012 Mathias Lafeldt
# Copyright (c) 2005-2012 Git project
# Copyright (c) 2005-2012 Junio C Hamano
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/ .

SHELL_PATH ?= $(SHELL)
SHELL_PATH_SQ = $(subst ','\'',$(SHELL_PATH))
RM ?= rm -f
PROVE ?= prove
AGGREGATE_SCRIPT ?= aggregate-results.sh
DEFAULT_TEST_TARGET ?= test

T = $(sort $(wildcard *.t))

all: $(DEFAULT_TEST_TARGET)

test: pre-clean
	$(MAKE) aggregate-results-and-cleanup

prove: pre-clean
	@echo "*** prove ***"; $(PROVE) --exec '$(SHELL_PATH_SQ)' $(PROVE_OPTS) $(T) :: $(TEST_OPTS)
	$(MAKE) clean-except-prove-cache

$(T):
	@echo "*** $@ ***"; '$(SHELL_PATH_SQ)' $@ $(TEST_OPTS)

pre-clean:
	$(RM) -r test-results

clean-except-prove-cache:
	$(RM) -r 'trash directory'.* test-results

clean: clean-except-prove-cache
	$(RM) .prove

aggregate-results-and-cleanup: $(T)
	$(MAKE) aggregate-results
	$(MAKE) clean

aggregate-results:
	for f in test-results/*.counts; do \
		echo "$$f"; \
	done | '$(SHELL_PATH_SQ)' '$(AGGREGATE_SCRIPT)'

.PHONY: all test prove $(T) pre-clean clean
.PHONY: aggregate-results-and-cleanup aggregate-results

=== contrib/mate-panel/Makefile ===
MATE_APPLET_DIR = /usr/share/mate-panel/applets
SERVICE_DIR = /usr/share/dbus-1/services
BINDIR = $(HOME)/bin

install:
	install -d $(MATE_APPLET_DIR)
	install -m644 org.mate.panel.JgMenuApplet.mate-panel-applet $(MATE_APPLET_DIR)
	install -d $(SERVICE_DIR)
	install -m644 org.mate.panel.applet.JgMenuAppletFactory.service $(SERVICE_DIR)
	install -m755 mate-jgmenu.py /home/johan/bin

=== contrib/pmenu/Makefile ===
-include ../../config.mk
include ../../Makefile.inc

pmenu:
	@:

install:
	@install -d $(DESTDIR)$(libexecdir)/jgmenu
	@install -m775 jgmenu-pmenu.py $(DESTDIR)$(libexecdir)/jgmenu

uninstall:
	@rm -f $(libexecdir)/jgmenu-pmenu.py

clean:

=== contrib/xdg/Makefile ===
CC      =  gcc
CFLAGS  =  -g -Wall
CFLAGS  += `xml2-config --cflags`
LIBS    += `xml2-config --libs`

path = ../../src/
src  = util.c sbuf.c xdgdirs.c argv-buf.c charset.c compat.c

jgmenu-xdg: jgmenu-xdg.c xdgapps.c
	$(CC) $(CFLAGS) -o $@ $^ $(addprefix $(path),$(src)) -I$(path) $(LIBS)

=== contrib/xfce4-panel/Makefile ===
-include ../../config.mk
include ../../Makefile.inc

libdir    ?= `pkg-config --variable=libdir libxfce4panel-2.0`
LIBDIR     = $(DESTDIR)$(libdir)/xfce4/panel/plugins
PLUGIN_DIR = $(DESTDIR)$(prefix)/share/xfce4/panel/plugins

CFLAGS  += -Wno-strict-prototypes -Wno-declaration-after-statement
CFLAGS  += -s -shared -fPIC
CFLAGS  += `pkg-config --cflags libxfce4panel-2.0`
LDFLAGS += `pkg-config --libs   libxfce4panel-2.0`

xfce4-panel: libjgmenu.so

libjgmenu.so: jgmenu-applet.c
	$(QUIET_CC)$(CC) $(CFLAGS) -o libjgmenu.so jgmenu-applet.c $(LDFLAGS)

install:
	@install -d $(LIBDIR)
	@install -m644 libjgmenu.so $(LIBDIR)
	@install -d $(PLUGIN_DIR)
	@install -m644 jgmenu-applet.desktop $(PLUGIN_DIR)

uninstall:
	@rm -f $(LIBDIR)/libjgmenu.so
	@rm -f $(PLUGIN_DIR)/jgmenu-applet.desktop

clean:
	@rm -f libjgmenu.so

=== debian/changelog ===
jgmenu (4.4.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards Version to 4.6.1.

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Mon, 14 Nov 2022 22:34:28 +0100

=== debian/control ===
Source: jgmenu
Maintainer: Mateusz Łukasik <mati75@linuxmint.pl>
Section: x11
Priority: optional
Standards-Version: 4.6.1
Homepage: https://jgmenu.github.io/
Build-Depends: debhelper-compat (= 13), libx11-dev, libxrandr-dev, libcairo2-dev,
 libpango1.0-dev, librsvg2-dev, libxml2-dev, libglib2.0-dev, libmenu-cache-dev,
 pkg-config, libgtk-3-dev, libxfce4panel-2.0-dev
Vcs-Git: https://github.com/mati75/jgmenu.git
Vcs-Browser: https://github.com/mati75/jgmenu
Rules-Requires-Root: no

Package: jgmenu
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, python3:any
Suggests: lxmenu-data
Description: Simple X11 menu
 A stand-alone, contemporary-looking menu application for Linux and BSD.
 Independent of window manager and panel. Designed for customisation,
 scripting, ricing and tweaking

Package: jgmenu-xfce4-panel-applet
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, jgmenu (= ${binary:Version})
Description: xfce4-panel applet for jgmenu
 A stand-alone, contemporary-looking menu application for Linux and BSD.
 Independent of window manager and panel. Designed for customisation,
 scripting, ricing and tweaking
 .
 This package provides xfce4-panel applet for jgmenu

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,3 @@
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr CONTRIB_DIRS="xfce4-panel gtktheme lx"
-
-# No dbgsym package for MX:
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

## jgmenu 4.5.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #
 # Define ASAN=1 to enable AddressSanitizer
+# Define RSVG=1 to enable SVG icon support
 #
 # Define VERBOSE=1 for a more verbose compilation
 #
@@ -12,13 +13,13 @@
 -include config.mk
 include Makefile.inc
 
-jgmenu:         CFLAGS += `pkg-config cairo pango pangocairo librsvg-2.0 --cflags`
+jgmenu:         CFLAGS += `pkg-config cairo pango pangocairo $(RSVG_LIB) --cflags` $(RSVG_FLAGS)
 jgmenu-ob:      CFLAGS += `xml2-config --cflags`
 jgmenu-obtheme: CFLAGS += `xml2-config --cflags`
 jgmenu-config:  CFLAGS += `pkg-config --cflags glib-2.0`
 jgmenu-apps:    CFLAGS += `pkg-config --cflags glib-2.0`
 
-jgmenu:         LIBS   += `pkg-config x11 xrandr cairo pango pangocairo librsvg-2.0 --libs`
+jgmenu:         LIBS   += `pkg-config x11 xrandr cairo pango pangocairo $(RSVG_LIB) --libs` $(RSVG_FLAGS)
 jgmenu:         LIBS   += -pthread -lpng
 jgmenu-ob:      LIBS   += `xml2-config --libs`
 jgmenu-obtheme: LIBS   += `xml2-config --libs`

=== docs/manual/Makefile ===
man1pages  = jgmenu.1 jgmenu_run.1 jgmenu-pmenu.1 jgmenu-lx.1 jgmenu-ob.1 \
	     jgmenu-apps.1 jgmenu-i18n.1
man7pages  = jgmenututorial.7 jgmenuunicode.7
manpages   = $(man1pages) $(man7pages)

prefix ?= /usr/local
mandir ?= $(prefix)/share/man
man1dir = $(mandir)/man1
man7dir = $(mandir)/man7

all: $(manpages)

$(manpages): % : %.md
	@echo "    PANDOC    " $^
	@pandoc -s -t man $^ -o $@
	@sed -i 's/\\\\\\\\/\\\\/' $@

install:
	@install -d -m 755 $(DESTDIR)$(man1dir)
	@install -d -m 755 $(DESTDIR)$(man7dir)
	@install -m 644 $(man1pages) $(DESTDIR)$(man1dir)
	@install -m 644 $(man7pages) $(DESTDIR)$(man7dir)

clean:
	@rm -f $(manpages)

=== debian/changelog ===
jgmenu (4.5.0-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 15 Feb 2025 15:03:55 -0800

jgmenu (4.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop all patches included upstream.
  * Add libxfce4ui-2-dev to B-D. (Closes: #1091058)
  * Bump Standards Version to 4.7.0.
  * Switch B-D pkg-config → pkgconf

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Fri, 03 Jan 2025 20:36:14 +0100

jgmenu (4.4.1-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

  [ Mateusz Łukasik ]
  * Backport upstream changes related to fix working with xfce4-panel.
    (Closes: #1063667)
  * Bump Standards Version to 4.6.2.
  * Add python3-gi, x11-xserver-utils to depends.

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Fri, 16 Feb 2024 20:37:07 +0100

=== debian/control ===
Source: jgmenu
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Mateusz Łukasik <mati75@linuxmint.pl>
Section: x11
Priority: optional
Standards-Version: 4.7.0
Homepage: https://jgmenu.github.io/
Build-Depends: debhelper-compat (= 13),
               libcairo2-dev,
               libglib2.0-dev,
               libgtk-3-dev,
               libmenu-cache-dev,
               libpango1.0-dev,
               librsvg2-dev,
               libx11-dev,
               libxfce4panel-2.0-dev,
               libxfce4ui-2-dev,
               libxml2-dev,
               libxrandr-dev,
               pkgconf
Vcs-Git: https://github.com/mati75/jgmenu.git
Vcs-Browser: https://github.com/mati75/jgmenu
Rules-Requires-Root: no

Package: jgmenu
Architecture: any
Multi-Arch: foreign
Depends: python3-gi,
         python3:any,
         x11-xserver-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: lxmenu-data
Description: Simple X11 menu
 A stand-alone, contemporary-looking menu application for Linux and BSD.
 Independent of window manager and panel. Designed for customisation,
 scripting, ricing and tweaking

Package: jgmenu-xfce4-panel-applet
Architecture: any
Multi-Arch: same
Depends: jgmenu (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: xfce4-panel applet for jgmenu
 A stand-alone, contemporary-looking menu application for Linux and BSD.
 Independent of window manager and panel. Designed for customisation,
 scripting, ricing and tweaking
 .
 This package provides the XFCE panel applet for jgmenu

=== debian/rules ===
--- 
+++ 
@@ -19,3 +19,8 @@
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr CONTRIB_DIRS="xfce4-panel gtktheme lx"
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym
